#ifndef MINO_HPP
#define MINO_HPP

#include <oiran/linda/button_input.hpp>
#include <oiran/linda/graphics.hpp>
#include "defs.hpp"


class next_mino_t
{
public:
	enum { set_size = 2 };

	next_mino_t();

	void init();
	void pop();
	void draw(oiran::linda::graphics_t& g);

	int top() const	{ return M_minos[M_index]; }

private:
	int M_minos[number_of_minos * set_size];
	int M_index;
};


class field_t;


class mino_t
{
public:
	enum {
		left,
		right,
		next_index_size
	};

	enum {
		wait,
		entry_wait,
		on_field,
		game_over,
		game_clear
	};

	static const int entry_x;
	static const int entry_y;
	static const int are;
	static const int lock_delay;
	static const int auto_shift_delay;
	static const int max_level;

	mino_t();

	void init(oiran::linda::button_input_t* input, field_t* field);
	void update();
	void draw(oiran::linda::graphics_t& g);

	void entry();
	void level_up(int value);

	int level() const { return M_level; }
	bool is_game_over() const { return M_state == game_over; }
	bool is_game_clear() const { return M_state == game_clear; }

private:
	void _entry();
	void _shift(int x);
	void _rotate(int next_index);
	void _soft_drop();
	void _hard_drop();
	void _down();
	void _lock();
	void _down_by_gravity();

private:
	oiran::linda::button_input_t* M_input;
	field_t* M_field;

	next_mino_t M_next_mino;

	int M_state;
	int M_state_count;
	const int* M_blocks;
	int M_next_indexs[next_index_size];
	int M_x;
	int M_y;
	int M_level;
	int M_gravity;
	int M_gravity_delay;
	int M_gravity_count;
	int M_lock_count;
};


#endif // MINO_HPP
