#include <algorithm>
#include <fstream>
#include <iterator>
#include <sstream>
#include <stdexcept>
#include "defs.hpp"
#include "ranking.hpp"


ranking_t::ranking_t() :
		M_update_index(-1)
{
	std::fill(M_scores, M_scores + ranking_size, 0);
}

void
ranking_t::load()
{
	std::ifstream in(save_file);
	if(in)
		for(int i = 0; i < ranking_size; ++i)
			in >> M_scores[i];
}

void
ranking_t::save()
{
	std::ofstream out(save_file);
	if(!out)
	{
		std::ostringstream oss;
		oss << "failed to save ranking : " << save_file;
		throw std::runtime_error(oss.str());
	}

	for(int i = 0; i < ranking_size; ++i)
		out << M_scores[i] << std::endl;
}

void
ranking_t::update(int new_score)
{
	int index = 0;
	for(; index < ranking_size; ++index)
		if(new_score >= M_scores[index])
		{
			for(int i = ranking_size - 1; i > index; --i)
			{
				std::ostringstream src_oss;
				std::ostringstream dst_oss;
				src_oss << i - 1 << ".dat";
				dst_oss << i << ".dat";
				_copy_file(src_oss.str().c_str(), dst_oss.str().c_str());
				M_scores[i] = M_scores[i - 1];
			}
			M_scores[index] = new_score;
			break;
		}

	if(index != ranking_size)
	{
		M_update_index = index;
		std::ostringstream oss;
		oss << index << ".dat";
		_copy_file(last_relay_file, oss.str().c_str());
	}
}

void
ranking_t::_copy_file(const char* src, const char* dst)
{
	std::ifstream in(src, std::ios::binary);
	if(in)
	{
		std::ofstream out(dst, std::ios::binary);
		std::copy(std::istreambuf_iterator<char>(in),
				std::istreambuf_iterator<char>(),
				std::ostreambuf_iterator<char>(out));
	}
}
