#ifndef TTRS_HPP
#define TTRS_HPP

#include <oiran/linda/button_input.hpp>
#include <oiran/linda/graphics.hpp>
#include "field.hpp"
#include "mino.hpp"


class ttrs_t
{
public:
	enum {
		start_wait,
		on_play,
		game_over_wait,
		game_over
	};

	ttrs_t();

	void init(oiran::linda::button_input_t* input);
	void update();
	void draw(oiran::linda::graphics_t& g);

	int score() const { return M_field.score(); }
	bool is_game_over() const { return M_state == game_over; }

private:
	oiran::linda::button_input_t* M_input;

	mino_t M_mino;
	field_t M_field;

	int M_state;
	int M_state_count;
};


#endif // TTRS_HPP
