#include <ctime>
#include <oiran/random.hpp>
#include "ttrs_replay.hpp"


ttrs_replay_t::ttrs_replay_t() :
		M_replay_flag(false)
{
}

void
ttrs_replay_t::init(const char* file_name)
{
	M_in.clear();
	if(M_in.is_open())
		M_in.close();

	M_in.open(file_name, std::ios::binary);
	if(M_in)
	{
		M_replay_flag = true;

		std::time_t seed;
		M_in.read(reinterpret_cast<char*>(&seed), sizeof(seed));
		oiran::random_seed(seed);

		M_replay.start_replay(M_in);
		M_ttrs.init(&M_replay);
	}
	else
		M_replay_flag = false;
}

void
ttrs_replay_t::update()
{
	if(M_replay_flag)
		M_ttrs.update();
}

void
ttrs_replay_t::draw(oiran::linda::graphics_t& g)
{
	if(M_replay_flag)
		M_ttrs.draw(g);
}
